import xc_base
import geom
import xc

from materials.sections import section_properties
from materials import typical_materials as tm

def create_lines(
    p1,
    p2,
    n: int,
    points,
    lines,
    point_id,
    )-> list:
    x1, y1, z1 = p1.getPos.x, p1.getPos.y, p1.getPos.z
    x2, y2, z2 = p2.getPos.x, p2.getPos.y, p2.getPos.z
    dx = (x2 - x1) / n
    dy = (y2 - y1) / n
    dz = (z2 - z1) / n
    
    first_point = p1
    new_lines = []
    for i in range(n):
        point_id += 1
        x = first_point.getPos.x + dx
        y = first_point.getPos.y + dy
        z = first_point.getPos.z + dz
        if all((x == x2, y == y2, z == z2)):
            last_point = p2
        else:
            last_point = points.newPntIDPos3d(point_id, geom.Pos3d(x, y, z))
        l = lines.newLine(first_point.tag, last_point.tag)
        new_lines.append(l)
        first_point = last_point
    return new_lines, point_id


def apply_nonPrismatic_section(sets, bf, tf, tw, hw_min, hw_max, \
                               coordTransf, modelSpace, material, prep):
    tag = 'isection'
    isection = section_properties.ISection(tag,bf,tf,tw,hw_min,bf,tf)
    linel_mat= tm.BeamMaterialData(name=tag, section=isection, material=material)
    linel_mat.setupElasticShear3DSection(preprocessor=prep)
    for Set in sets:
        # tag = Set.getLines[0].tag
        # n = Set.lines.size
        # dhw = hw_max - hw_min
        # for line in Set.lines:
        #     z = line.getCentroid().z
        #     average_hw = hw_min + z / h_col * dhw
        #     isection = section_properties.ISection(f"isection{line.tag}",bf,tf,tw,average_hw,bf,tf)
        #     p1 = line.getP1().tag
        #     p2 = line.getP2().tag
        #     seedElemHandler.defaultMaterial = isection.sectionName
        #     seedElemHandler.newElement('elastic_beam3d', xc.ID([p1, p2]))
        modelSpace.createElasticBeams(Set, linel_mat, coordTransf, xc.Vector([0.0,1.0,0.0]), nDiv= 4)
